our @trigger_data = ( [

# Conditions:

'xsUserCondition' => [ ('xsUserCondition'), [
  [ 'MyString' => ('Code'), 'Code', 'string' ],
 ], [
  '(%MyString%)',
 ], [
 ] ],

'Always' => [ ('Always'), [], [
  'true',
 ], [] ],
'Timer' => [ ('Timer'), [
  [ 'Param1' => ('Value'), 'Seconds', 'long' ],
 ], [
  '(trTime()-cActivationTime) >= %Param1%',
 ], [] ],
'Timer ms' => [ ('Timer ms'), [
  [ 'Param1' => ('Value'), 'Milliseconds', 'long' ],
 ], [
  '(trTimeMS()-(cActivationTime*1000)) >= %Param1%',
 ], [] ],
'Distance to Unit' => [ ('Distance to Unit'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'DstObject' => ('TargetUnit'), 'Target Unit', 'unit' ],
  [ 'Op' => ('Operator'), 'Operator', 'operator' ],
  [ 'Dist' => ('Distance'), 'Distance', 'float' ],
 ], [
  'trUnitDistanceToUnit("%DstObject%") %Op% %Dist%',
 ], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
 ] ],
'Units in Area' => [ ('Units in Area'), [
  [ 'DstObject' => ('CenterUnit'), 'Center Unit', 'unit' ],
  [ 'Player' => ('PlayerID'), 'Player', 'player' ],
  [ 'UnitType' => ('UnitType'), 'Unit Type', 'string' ],
  [ 'Dist' => ('Radius'), 'Radius', 'float' ],
  [ 'Op' => ('Operator'), 'Operator', 'operator' ],
  [ 'Count' => ('Count'), 'Count', 'float' ],
 ], [
  'trCountUnitsInArea("%DstObject%",%Player%,"%UnitType%",%Dist%) %Op% %Count%',
 ], [] ],
'Distance to Point' => [ ('Distance to Point'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'DstPoint' => ('TargetPoint'), '', 'area' ],
  [ 'Op' => ('Operator'), 'Operator', 'operator' ],
  [ 'Dist' => ('Distance'), 'Distance', 'float' ],
 ], [
  'trUnitDistanceToPoint(%DstPoint%) %Op% %Dist%',
 ], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
 ] ],
'Is Alive' => [ ('Is Alive'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
 ], [
  'trUnitAlive()==true',
 ], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
 ] ],
'Is Dead' => [ ('Is Dead'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
 ], [
  'trUnitDead()==true',
 ], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
 ] ],
'Visible to Player' => [ ('Visible to Player'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
 ], [
  'trUnitVisToPlayer()==true',
 ], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
 ] ],
'Units in LOS' => [ ('Units in LOS'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
 ], [
  'trUnitHasLOS(%PlayerID%)',
 ], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
 ] ],
'Tech Available' => [ ('Tech Available'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'TechID' => ('TechID'), 'Tech', 'tech' ],
 ], [
  'trTechStatusActive(%PlayerID%, %TechID%)',
 ], [] ],
'Tech Researching' => [ ('Tech Researching'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'TechID' => ('TechID'), 'Tech', 'tech' ],
 ], [
  'trTechStatusResearching(%PlayerID%, %TechID%)',
 ], [] ],
'Percent Complete' => [ ('Percent Complete'), [
  [ 'SrcObject' => ('SourceUnit'), 'Source Unit', 'unit' ],
  [ 'Op' => ('Operator'), 'Operator', 'operator' ],
  [ 'Percent' => ('Percent'), 'Percent', 'long' ],
 ], [
  'trUnitPercentComplete() %Op% %Percent%',
 ], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', undef,
 ] ],
'Percent Damaged' => [ ('Percent Damaged'), [
  [ 'SrcObject' => ('SourceUnit'), 'Source Unit', 'unit' ],
  [ 'Op' => ('Operator'), 'Operator', 'operator' ],
  [ 'Percent' => ('Percent'), 'Percent', 'long' ],
 ], [
  'trUnitPercentDamaged() %Op% %Percent%',
 ], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', undef,
 ] ],
'All Units Dead' => [ ('All Units Dead'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
 ], [
  'trPlayerUnitCount(%PlayerID%)==0',
 ], [] ],
'All Buildings Dead' => [ ('All Buildings Dead'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
 ], [
  'trPlayerBuildingCount(%PlayerID%)==0',
 ], [] ],
'All Units And Buildings Dead' => [ ('All Units And Buildings Dead'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
 ], [
  'trPlayerUnitAndBuildingCount(%PlayerID%)==0',
 ], [] ],
'Player Is Building' => [ ('Player Is Building'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'ProtoUnit' => ('ProtoUnit'), 'Unit', 'protounit' ],
  [ 'Op' => ('Operator'), 'Operator', 'operator' ],
  [ 'Count' => ('Count'), 'Number', 'long' ],
 ], [
  'trPlayerCountBuildingInProgress(%PlayerID%, "%ProtoUnit%") %Op% %Count%',
 ], [] ],
'Player Unit Count' => [ ('Player Unit Count'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'ProtoUnit' => ('ProtoUnit'), 'Unit', 'protounit' ],
  [ 'Op' => ('Operator'), 'Operator', 'operator' ],
  [ 'Count' => ('Count'), 'Number', 'long' ],
 ], [
  'trPlayerUnitCountSpecific(%PlayerID%, "%ProtoUnit%") %Op% %Count%',
 ], [] ],
'Player Resource Count' => [ ('Player Resource Count'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'Resource' => ('Resource'), 'Resource', 'resource' ],
  [ 'Op' => ('Operator'), 'Operator', 'operator' ],
  [ 'Count' => ('Count'), 'Number', 'long' ],
 ], [
  'trPlayerResourceCount(%PlayerID%, "%Resource%") %Op% %Count%',
 ], [] ],
'Player Defeated' => [ ('Player Defeated'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
 ], [
  'trPlayerDefeated(%PlayerID%)',
 ], [] ],
'Player Active' => [ ('Player Active'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
 ], [
  'trPlayerActive(%PlayerID%)',
 ], [] ],
'Player At Pop Cap' => [ ('Player At Pop Cap'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
 ], [
  'trPlayerAtPopCap(%PlayerID%)',
 ], [] ],
'Player at Pop Cap' => [ ('Player at Pop Cap'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
 ], [
  'trPlayerAtPopCap(%PlayerID%)',
 ], [] ],
'Player Population' => [ ('Player Population'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'Op' => ('Operator'), 'Operator', 'operator' ],
  [ 'Count' => ('Count'), 'Number', 'long' ],
 ], [
  'trPlayerGetPopulation(%PlayerID%) %Op% %Count%',
 ], [] ],
'Units Garrisoned' => [ ('Units Garrisoned'), [
  [ 'SrcObject' => ('SourceUnit'), 'Source Unit', 'unit' ],
  [ 'Op' => ('Operator'), 'Operator', 'operator' ],
  [ 'Count' => ('Count'), 'Number', 'long' ],
 ], [
  'trUnitGetContained() %Op% %Count%',
 ], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', undef,
 ] ],
'Unit Selected' => [ ('Unit Selected'), [
  [ 'SrcObject' => ('SourceUnit'), 'Source Unit', 'unit' ],
 ], [
  'trUnitIsSelected()',
 ], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', undef,
 ] ],
'Unit Type Selected' => [ ('Unit Type Selected'), [
  [ 'ProtoUnit' => ('ProtoUnit'), 'Unit', 'protounit' ],
 ], [
  'trUnitTypeIsSelected("%ProtoUnit%")',
 ], [] ],
'Diplomacy Change' => [ ('Diplomacy Change'), [
  [ 'Player1' => ('Player1'), 'Player', 'player' ],
  [ 'Status' => ('Status'), 'Status', 'alliance' ],
  [ 'Player2' => ('Player2'), 'Player', 'player' ],
 ], [
  'trPlayerGetDiplomacy(%Player1%, %Player2%) == "%Status%"',
 ], [] ],
'Units Owned' => [ ('Units Owned'), [
  [ 'Player' => ('PlayerID'), 'Player', 'player' ],
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
 ], [
  'trUnitIsOwnedBy(%Player%)',
 ], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
 ] ],
'Abort Cinematic' => [ ('Abort Cinematic'), [], [
  'trCinematicAbort()',
 ], [] ],
'Difficulty Level' => [ ('Difficulty Level'), [
  [ 'Op' => ('Operator'), 'Operator', 'operator' ],
  [ 'Level' => ('Level'), 'Level', 'long' ],
 ], [
  'trGetWorldDifficulty() %Op% %Level%',
 ], [] ],
'Gadget Visible' => [ ('Gadget Visible'), [
  [ 'Gadget' => ('Gadget'), 'Gadget', 'string' ],
 ], [
  'trIsGadgetVisible("%Gadget%")',
 ], [] ],
'Army Distance to Unit' => [ ('Army Distance to Unit'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'DstObject' => ('TargetUnit'), 'Target Unit', 'unit' ],
  [ 'Op' => ('Operator'), 'Operator', 'operator' ],
  [ 'Dist' => ('Distance'), 'Distance', 'float' ],
 ], [
  'trUnitDistanceToUnit("%DstObject%") %Op% %Dist%',
 ], [
  'trArmySelect("%SrcArmy%");', undef,
 ] ],
'Army Distance to Point' => [ ('Army Distance to Point'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'DstPoint' => ('TargetPoint'), '', 'area' ],
  [ 'Op' => ('Operator'), 'Operator', 'operator' ],
  [ 'Dist' => ('Distance'), 'Distance', 'float' ],
 ], [
  'trUnitDistanceToPoint(%DstPoint%) %Op% %Dist%',
 ], [
  'trArmySelect("%SrcArmy%");', undef,
 ] ],
'Army in LOS' => [ ('Army in LOS'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
 ], [
  'trUnitHasLOS(%PlayerID%)',
 ], [
  'trArmySelect("%SrcArmy%");', undef,
 ] ],
'Army Visible to Player' => [ ('Army Visible to Player'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
 ], [
  'trUnitVisToPlayer()==true',
 ], [
  'trArmySelect("%SrcArmy%");', undef,
 ] ],
'Army Is Alive' => [ ('Army Is Alive'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
 ], [
  'trUnitAlive()==true',
 ], [
  'trArmySelect("%SrcArmy%");', undef,
 ] ],
'Army Is Dead' => [ ('Army Is Dead'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
 ], [
  'trUnitDead()==true',
 ], [
  'trArmySelect("%SrcArmy%");', undef,
 ] ],
'Army Owned' => [ ('Army Owned'), [
  [ 'Player' => ('PlayerID'), 'Player', 'player' ],
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
 ], [
  'trUnitIsOwnedBy(%Player%)',
 ], [
  'trArmySelect("%SrcArmy%");', undef,
 ] ],


'Unit Build Building' => [ ('Unit Build Building_c'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'ProtoUnit' => ('ProtoUnit'), 'ProtoUnit To Build', 'protounit' ],
  [ 'DstPoint' => ('TargetPoint'), 'Build Location', 'area' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitBuildUnit("%ProtoUnit%", vector(%DstPoint%));', undef,
 ] ],
'Selection' => [ ('Units in Area By Name'), [
  [ 'DstObject' => ('CenterUnit'), 'Center Unit', 'unit' ],
  [ 'Player' => ('PlayerID'), 'Player', 'player' ],
  [ 'ProtoName' => ('ProtoName'), 'Unit Type', 'protounit' ],
  [ 'Dist' => ('Radius'), 'Radius', 'float' ],
  [ 'Op' => ('Operator'), 'Operator', 'operator' ],
  [ 'Count' => ('Count'), 'Count', 'float' ],
 ], [
  'trCountUnitsInArea("%DstObject%",%Player%,"%ProtoName%",%Dist%) %Op% %Count%',
 ], [] ],
'Move to Unit' => [ ('Move To Unit'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'DstObject' => ('TargetUnit'), 'Target Unit', 'unit' ],
  [ 'AttackMove' => ('AttackMove'), 'Attack Move', 'bool' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitMoveToUnit("%DstObject%", %AttackMove%);', undef,
 ] ],
'Set Cut' => [ ('Timer Set Camera Cut'), [
  [ 'CameraInfo' => ('CameraInfo'), 'Set Cut', 'camerainfo' ],
  [ 'Param1' => ('Value'), 'Milliseconds', 'long' ],
 ], [
  '(trTimeMS()-(cActivationTime*1000)) >= %Param1%',
 ], [
  'trCameraCut(%CameraInfo%);', undef,
 ] ],


], [

# Effects:

'SetIdleProcessing' => [ ('SetIdleProcessing'), [
  [ 'IdleProc' => ('ProcessIdle'), 'Process Idle:', 'bool' ],
 ], [], [
  'trSetUnitIdleProcessing(%IdleProc%);', undef,
 ] ],
'SetObscuredUnits' => [ ('SetObscuredUnits'), [
  [ 'IdleProc' => ('ObscureUnits'), 'Obscure Units:', 'bool' ],
 ], [], [
  'trSetObscuredUnits(%IdleProc%);', undef,
 ] ],
'Set Animation' => [ ('Set Animation'), [
  [ 'SrcObject' => ('SourceUnits'), 'Unit', 'unit' ],
  [ 'AnimName' => ('AnimName'), 'Animation', 'string' ],
  [ 'LoopIt' => ('Loop'), 'Loop:', 'bool' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitSetAnimation("%AnimName%",%LoopIt%,%EventID%);', undef,
 ] ],
'Army Set Animation' => [ ('Army Set Animation'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'AnimName' => ('AnimName'), 'Animation', 'string' ],
  [ 'LoopIt' => ('Loop'), 'Loop:', 'bool' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitSetAnimation("%AnimName%",%LoopIt%,%EventID%);', undef,
 ] ],
'Camera Track' => [ ('Camera Track'), [
  [ 'TrackName' => ('TrackName'), 'Name', 'camtrack' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
 ], [], [
  'trCamTrackLoad("%TrackName%");', undef,
  'trCamTrackPlay(-1, %EventID%);', undef,
 ] ],
'Cinematic Mode' => [ ('Cinematic Mode'), [
  [ 'Enter' => ('Enter'), 'Mode:', 'bool' ],
 ], [], [
  'trLetterBox(%Enter%);', undef,
 ] ],
'Force Non Cinematic Models' => [ ('Force Non Cinematic Models'), [
  [ 'OnOff' => ('OnOff'), 'OnOff:', 'bool' ],
 ], [], [
  'trForceNonCinematicModels(%OnOff%);', undef,
 ] ],
'Force Non-Cinematic Models' => [ ('Force Non-Cinematic Models'), [
  [ 'OnOff' => ('OnOff'), 'OnOff:', 'bool' ],
 ], [], [
  'trForceNonCinematicModels(%OnOff%);', undef,
 ] ],
'User Controls' => [ ('User Controls'), [
  [ 'Active' => ('Active'), 'Control:', 'bool' ],
 ], [], [
  'trSetCurrentPlayerStatus(%Active%);', undef,
 ] ],
'Chat Status' => [ ('Chat Status'), [
  [ 'Active' => ('Active'), 'Status:', 'bool' ],
 ], [], [
  'trChatSetStatus(%Active%);', undef,
 ] ],
'Render Sky' => [ ('Render Sky'), [
  [ 'Flag' => ('Render'), 'Render:', 'bool' ],
  [ 'TextureRootName' => ('TextureRootName'), 'Sky Name', 'string' ],
 ], [], [
  'trRenderSky(%Flag%, "%TextureRootName%");', undef,
 ] ],
'Render Snow' => [ ('Render Snow'), [
  [ 'Percent' => ('Percent'), 'Percent:', 'float' ],
 ], [], [
  'trRenderSnow(%Percent%);', undef,
 ] ],
'Render Fog/Black Map' => [ ('Render Fog/Black Map'), [
  [ 'Fog' => ('Fog'), 'Fog of War:', 'bool' ],
  [ 'Black' => ('Black'), 'Black Map:', 'bool' ],
 ], [], [
  'trSetFogAndBlackmap(%Fog%, %Black%);', undef,
 ] ],
'Camera Cut' => [ ('Camera Cut'), [
  [ 'CameraInfo' => ('CameraInfo'), 'Set Cut', 'camerainfo' ],
 ], [], [
  'trCameraCut(%CameraInfo%);', undef,
 ] ],
'Sound Filename' => [ ('Sound Filename'), [
  [ 'Sound' => ('Sound'), 'Sound', 'sound' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
  [ 'Subtitle' => ('Subtitle'), 'Subtitle', 'stringid' ],
  [ 'Portrait' => ('Portrait'), 'Portrait', 'string' ],
 ], [], [
  'trSoundPlayFN("%Sound%", %EventID%, "%Subtitle%","%Portrait%");', undef,
 ] ],
'Sound Play Paused' => [ ('Sound Play Paused'), [
  [ 'Sound' => ('Sound'), 'Sound', 'sound' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
  [ 'Subtitle' => ('Subtitle'), 'Subtitle', 'stringid' ],
  [ 'Portrait' => ('Portrait'), 'Portrait', 'string' ],
 ], [], [
  'trSoundPlayPaused("%Sound%", %EventID%, "%Subtitle%","%Portrait%");', undef,
 ] ],
'Sound Timer' => [ ('Sound Timer'), [
  [ 'Time' => ('Time_ms'), 'Milliseconds', 'long' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
 ], [], [
  'trSoundTimer(%Time%, %EventID%);', undef,
 ] ],
'FadeOutMusic' => [ ('FadeOutMusic'), [
  [ 'Duration' => ('Duration'), 'Fade Duration', 'float' ],
 ], [], [
  'trFadeOutMusic(%Duration%);', undef,
 ] ],
'PlayNextMusicTrack' => [ ('PlayNextMusicTrack'), [], [], [
  'trPlayNextMusicTrack();', undef,
 ] ],
'FadeOutAllSounds' => [ ('FadeOutAllSounds'), [
  [ 'Duration' => ('Duration'), 'Fade Duration', 'float' ],
 ], [], [
  'trFadeOutAllSounds(%Duration%);', undef,
 ] ],
'BlockAllSounds' => [ ('BlockAllSounds'), [
  [ 'Dialog' => ('ExcludeDialog'), 'Exclude Dialog', 'bool' ],
 ], [], [
  'trBlockAllSounds(%Dialog%);', undef,
 ] ],
'UnblockAllSounds' => [ ('UnblockAllSounds'), [], [], [
  'trUnblockAllSounds();', undef,
 ] ],
'BlockAllAmbientSounds' => [ ('BlockAllAmbientSounds'), [], [], [
  'trBlockAllAmbientSounds();', undef,
 ] ],
'UnblockAllAmbientSounds' => [ ('UnblockAllAmbientSounds'), [], [], [
  'trUnBlockAllAmbientSounds();', undef,
 ] ],
'Music Filename' => [ ('Music Filename'), [
  [ 'Music' => ('Music'), 'Music File', 'sound' ],
  [ 'Duration' => ('Duration'), 'Fade Duration', 'float' ],
 ], [], [
  'trMusicPlay("%Music%", %Duration%);', undef,
 ] ],
'Music Play' => [ ('Music Play'), [], [], [
  'trMusicPlayCurrent();', undef,
 ] ],
'Music Stop' => [ ('Music Stop'), [], [], [
  'trMusicStop();', undef,
 ] ],
'Set Current Music Set' => [ ('Set Current Music Set'), [
  [ 'SetID' => ('SetID'), 'Music Set Index', 'long' ],
 ], [], [
  'trMusicSetCurrentMusicSet(%SetID%);', undef,
 ] ],
'Play Dialog' => [ ('Play Dialog'), [
  [ 'Sound' => ('Sound'), 'Sound', 'sound' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
  [ 'Ignore' => ('IgnoreEventOnAbort'), 'Ignore Event on Abort', 'bool' ],
  [ 'Subtitle' => ('Subtitle'), 'Subtitle', 'stringid' ],
  [ 'Portrait' => ('Portrait'), 'Portrait', 'string' ],
 ], [], [
  'trSoundPlayDialog("%Sound%", %EventID%, %Ignore%, "%Subtitle%", "%Portrait%");', undef,
 ] ],
'Music Mood' => [ ('Music Mood'), [
  [ 'MoodID' => ('MoodID'), 'Mood ID', 'long' ],
 ], [], [
  'trMusicSetMood(%MoodID%);', undef,
 ] ],
'Teleport Units' => [ ('Teleport Units'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'Area' => ('Area'), '', 'area' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitTeleport(%Area%);', undef,
 ] ],

'Move To Point' => [ ('Move To Point'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'DstPoint' => ('TargetPoint'), 'X', 'area' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
  [ 'AttackMove' => ('AttackMove'), 'Attack Move', 'bool' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitMoveToPoint(%DstPoint%, %EventID%, %AttackMove%);', undef,
 ] ],
'Move to Point' => [ ('Move to Point'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'DstPoint' => ('TargetPoint'), 'X', 'area' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
  [ 'AttackMove' => ('AttackMove'), 'Attack Move', 'bool' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitMoveToPoint(%DstPoint%, %EventID%, %AttackMove%);', undef,
 ] ],

'Unit Build Building' => [ ('Unit Build Building'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'ProtoUnit' => ('ProtoUnit'), 'ProtoUnit To Build', 'protounit' ],
  [ 'DstPoint' => ('TargetPoint'), 'Build Location', 'area' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitBuildUnit("%ProtoUnit%", vector(%DstPoint%));', undef,
 ] ],
'Fire Event' => [ ('Fire Event'), [
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
 ], [], [
  'trEventFire(%EventID%);', undef,
 ] ],
'Move to Unit' => [ ('Move to Unit'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'DstObject' => ('TargetUnit'), 'Target Unit', 'unit' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
  [ 'AttackMove' => ('AttackMove'), 'Attack Move', 'bool' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitMoveToUnit("%DstObject%",%EventID%, %AttackMove%);', undef,
 ] ],
'Unit Work' => [ ('Unit Work'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'DstObject' => ('TargetUnit'), 'Target Unit', 'unit' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitDoWorkOnUnit("%DstObject%",%EventID%);', undef,
 ] ],
'Unit Garrison' => [ ('Unit Garrison'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'DstObject' => ('TargetUnit'), 'Target Unit', 'unit' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitGarrison("%DstObject%",%EventID%);', undef,
 ] ],
'Unit Immediate Garrison' => [ ('Unit Immediate Garrison'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'DstObject' => ('TargetUnit'), 'Target Unit', 'unit' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trImmediateUnitGarrison("%DstObject%");', undef,
 ] ],
'Destroy' => [ ('Destroy'), [
  [ 'SrcObject' => ('SourceUnits'), 'Unit', 'unit' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitDestroy();', undef,
 ] ],
'Kill' => [ ('Kill'), [
  [ 'SrcObject' => ('SourceUnits'), 'Units', 'unit' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitDelete(false);', undef,
 ] ],
'Convert' => [ ('Convert'), [
  [ 'SrcObject' => ('SourceUnits'), 'Unit', 'unit' ],
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitConvert(%PlayerID%);', undef,
 ] ],
'Disable Trigger' => [ ('Disable Trigger'), [
  [ 'TrigName' => ('TriggerName'), 'Name', 'string' ],
 ], [], [
  'xsDisableRule("_%TrigName%");', undef,
 ] ],
'Objective' => [ ('Objective'), [
  [ 'Mission' => ('Mission'), 'Mission', 'long' ],
  [ 'ID' => ('ID'), 'ID', 'long' ],
 ], [], [
  'trObjectiveSetID(%Mission%, %ID%);', undef,
 ] ],
'Message' => [ ('Message'), [
  [ 'Text' => ('Message'), 'Text', 'stringid' ],
  [ 'Timeout' => ('Timeout_ms'), 'Timeout (ms)', 'long' ],
 ], [], [
  'trMessageSetText("%Text%", %Timeout%);', undef,
 ] ],
'Set Tech Status' => [ ('Set Tech Status'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'TechID' => ('TechID'), 'Tech', 'tech' ],
  [ 'Status' => ('Status'), 'Status', 'techstatus' ],
 ], [], [
  'trTechSetStatus(%PlayerID%, %TechID%, %Status%);', undef,
 ] ],
'Unit Create' => [ ('Unit Create'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'ProtoName' => ('ProtoName'), 'ProtoName', 'protounit' ],
  [ 'ScenName' => ('ScenName'), 'Name', 'string' ], #############
  [ 'Location' => ('Location'), '', 'area' ],
  [ 'Heading' => ('Heading'), 'Heading', 'long' ],
 ], [], [
  'trUnitCreate("%ProtoName%", "%ScenName%", %Location%, %Heading%, %PlayerID%);', undef,
 ] ],
'Unit Create Multi' => [ ('Unit Create Multi'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'ProtoName' => ('ProtoName'), 'ProtoName', 'protounit' ],
  [ 'Location' => ('Location'), '', 'area' ],
  [ 'Count' => ('Count'), 'Count', 'long' ],
  [ 'Heading' => ('Heading'), 'Heading', 'long' ],
 ], [], [
  'for (i=0; <%Count%)', undef,
  '  trUnitCreate("%ProtoName%", "default", %Location%, %Heading%,, %PlayerID%);', undef,
#########                                                        ^^?
 ] ],
'Unit Heading' => [ ('Unit Heading'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'Heading' => ('Heading'), 'Heading', 'long' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitSetHeading(%Heading%);', undef,
 ] ],
'AI Func' => [ ('AI Func'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'FnName' => ('FunctionName'), 'FunctionName', 'string' ],
  [ 'Parameter' => ('Parameter'), 'Parameter', 'long' ],
 ], [], [
  'trAIFunc(%PlayerID%, "%FnName%", %Parameter%);', undef,
 ] ],
'You Win' => [ ('You Win'), [], [], [
  'trYouWin("%NextScen%");', undef,
 ] ],
'You Lose' => [ ('You Lose'), [], [], [
  'trYouLose();', undef,
 ] ],
'Campaign Dialog' => [ ('Campaign Dialog'), [
  [ 'Campaign' => ('Campaign'), 'Next Campaign', 'string' ],
  [ 'Text' => ('Message'), 'Message', 'stringid' ],
 ], [], [
  'trShowCampaignDlg("%Campaign%", "%Text%");', undef,
 ] ],
'Send Chat' => [ ('Send Chat'), [
  [ 'PlayerID' => ('FromPlayerID'), 'From Player', 'player' ],
  [ 'Message' => ('Message'), 'Message', 'stringid' ],
 ], [], [
  'trChatSend(%PlayerID%, "%Message%");', undef,
 ] ],
'Write To Log' => [ ('Write To Log'), [
  [ 'Message' => ('Message'), 'Message', 'string' ],
 ], [], [
  'trWriteToLog("%Message%");', undef,
 ] ],
'Highlight Units' => [ ('Highlight Units'), [
  [ 'SrcObject' => ('SourceUnits'), 'Units', 'unit' ],
  [ 'Duration' => ('Duration'), 'Seconds', 'float' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitHighlight(%Duration%, false);', undef,
 ] ],
'Move By Name' => [ ('Move By Name'), [
  [ 'SrcObject' => ('SourceUnit'), 'Name', 'string' ],
  [ 'DstPoint' => ('TargetPoint'), 'X', 'area' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
  [ 'AttackMove' => ('AttackMove'), 'Attack Move', 'bool' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', undef,
  'trUnitMoveToPoint(%DstPoint%, %EventID%, %AttackMove%);', undef,
 ] ],
'Change Unit Type' => [ ('Change Unit Type'), [
  [ 'SrcObject' => ('SourceUnits'), 'Unit', 'unit' ],
  [ 'ProtoUnit' => ('ProtoUnit'), 'ProtoUnit', 'protounit' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitChangeProtoUnit("%ProtoUnit%");', undef,
 ] ],
'Grant God Power' => [ ('Grant God Power'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'PowerName' => ('PowerName'), 'Power', 'godpower' ],
  [ 'Count' => ('Count'), 'Uses', 'long' ],
 ], [], [
  'trTechGodPower(%PlayerID%, "%PowerName%", %Count%);', undef,
 ] ],
'Tribute' => [ ('Tribute'), [
  [ 'FromPlayerID' => ('FromPlayerID'), 'From Player', 'player' ],
  [ 'ToPlayerID' => ('ToPlayerID'), 'To Player', 'player' ],
  [ 'ResName' => ('Resource'), 'Resource', 'resource' ],
  [ 'Amount' => ('Amount'), 'Amount', 'long' ],
 ], [], [
  'trPlayerTribute(%FromPlayerID%, "%ResName%", %Amount%, %ToPlayerID%);', undef,
 ] ],
'Grant Resources' => [ ('Grant Resources'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'ResName' => ('Resource'), 'Resource', 'resource' ],
  [ 'Amount' => ('Amount'), 'Amount', 'long' ],
 ], [], [
  'trPlayerGrantResources(%PlayerID%, "%ResName%", %Amount%);', undef,
 ] ],
'Ungarrison' => [ ('Ungarrison'), [
  [ 'SrcObject' => ('SourceUnit'), 'Unit', 'unit' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', undef,
  'trUnitEjectContained();', undef,
 ] ],
'Hide Score' => [ ('Hide Score'), [], [], [
  'gadgetUnreal("ScoreDisplay");', undef,
 ] ],
'Pause Game' => [ ('Pause Game'), [
  [ 'Pause' => ('Pause'), 'Pause:', 'bool' ],
 ], [], [
  'trGamePause(%Pause%);', undef,
 ] ],
'Diplomacy' => [ ('Diplomacy'), [
  [ 'Player1' => ('Player1'), 'Player', 'player' ],
  [ 'Status' => ('Status'), 'Status', 'alliance' ],
  [ 'Player2' => ('Player2'), 'Player', 'player' ],
 ], [], [
  'trPlayerSetDiplomacy(%Player1%, %Player2%, "%Status%");', undef,
 ] ],
'Army Deploy' => [ ('Army Deploy'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'ProtoName' => ('ProtoName'), 'ProtoName', 'protounit' ],
  [ 'Location' => ('Location'), '', 'area' ],
  [ 'Count' => ('Count'), 'Count', 'long' ],
  [ 'Heading' => ('Heading'), 'Heading', 'long' ],
  [ 'Clear' => ('ClearExistingUnits'), 'Clear Existing Units', 'bool' ],
 ], [], [
  'trArmyDispatch("%SrcArmy%", "%ProtoName%", %Count%, %Location%, %Heading%, %Clear%);', undef,
 ] ],
'Army Teleport' => [ ('Army Teleport'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'Area' => ('Area'), '', 'area' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitTeleport(%Area%);', undef,
 ] ],
'Army Move' => [ ('Army Move'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'DstPoint' => ('TargetPoint'), 'X', 'area' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
  [ 'AttackMove' => ('AttackMove'), 'Attack Move', 'bool' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitMoveToPoint(%DstPoint%, %EventID%, %AttackMove%);', undef,
 ] ],
'Army Move to Unit' => [ ('Army Move to Unit'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'DstObject' => ('TargetUnit'), 'Target Unit', 'unit' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
  [ 'AttackMove' => ('AttackMove'), 'Attack Move', 'bool' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitMoveToUnit("%DstObject%",%EventID%, %AttackMove%);', undef,
 ] ],
'Army Work' => [ ('Army Work'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'DstObject' => ('TargetUnit'), 'Target Unit', 'unit' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitDoWorkOnUnit("%DstObject%",%EventID%);', undef,
 ] ],
'Army Garrison' => [ ('Army Garrison'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'DstObject' => ('TargetUnit'), 'Target Unit', 'unit' ],
  [ 'EventID' => ('TriggerName'), 'Trigger', 'event' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitGarrison("%DstObject%",%EventID%);', undef,
 ] ],
'Army Destroy' => [ ('Army Destroy'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitDelete();', undef,
 ] ],
'Army Kill' => [ ('Army Kill'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitDelete(false);', undef,
 ] ],
'Army Convert' => [ ('Army Convert'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitConvert(%PlayerID%);', undef,
 ] ],
'Army Highlight' => [ ('Army Highlight'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'Duration' => ('Duration'), 'Seconds', 'float' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitHighlight(%Duration%, false);', undef,
 ] ],
'Army Change Type' => [ ('Army Change Type'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'ProtoUnit' => ('ProtoUnit'), 'ProtoUnit', 'protounit' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitChangeProtoUnit("%ProtoUnit%");', undef,
 ] ],
'Army Set Stance' => [ ('Army Set Stance'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'Stance' => ('Stance'), 'Stance', 'unitstance' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitSetStance("%Stance%");', undef,
 ] ],
'Army Flash' => [ ('Army Flash'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'Duration' => ('Duration'), 'Seconds', 'float' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitHighlight(%Duration%, true);', undef,
 ] ],
'Army Heading' => [ ('Army Heading'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'Heading' => ('Heading'), 'Heading', 'long' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitSetHeading(%Heading%);', undef,
 ] ],
'Army Build Building' => [ ('Army Build Building'), [
  [ 'SrcArmy' => ('SourceArmy'), 'Army', 'group' ],
  [ 'ProtoUnit' => ('ProtoUnit'), 'ProtoUnit To Build', 'protounit' ],
  [ 'DstPoint' => ('TargetPoint'), 'Build Location', 'area' ],
 ], [], [
  'trArmySelect("%SrcArmy%");', undef,
  'trUnitBuildUnit("%ProtoUnit%", vector(%DstPoint%));', undef,
 ] ],
'Set Lighting' => [ ('Set Lighting'), [
  [ 'SetName' => ('SetName'), 'Set Name:', 'string' ],
  [ 'FadeTime' => ('FadeTime'), 'Fade In:', 'float' ],
 ], [], [
  'trSetLighting("%SetName%",%FadeTime%);', undef,
 ] ],
'Invoke God Power' => [ ('Invoke God Power'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'PowerName' => ('PowerName'), 'Power', 'godpower' ],
  [ 'DstPoint1' => ('TargetPoint1'), 'X', 'area' ],
  [ 'DstPoint2' => ('TargetPoint2'), 'X', 'area' ],
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trTechInvokeGodPower(%PlayerID%, "%PowerName%", vector(%DstPoint1%), vector(%DstPoint2%));', undef,
 ] ],
'Counter:Add Timer' => [ ('Counter:Add Timer'), [
  [ 'Name' => ('CounterName'), 'Name', 'string' ],
  [ 'Start' => ('Start'), 'Start', 'long' ],
  [ 'Stop' => ('Stop'), 'Stop', 'long' ],
  [ 'Msg' => ('Message'), 'Message', 'stringid' ],
  [ 'Event' => ('Event'), 'Trigger', 'event' ],
 ], [], [
  'trCounterAddTime("%Name%", %Start%, %Stop%, "%Msg%", %Event%);', undef,
 ] ],
'Counter:Add Unit' => [ ('Counter:Add Unit'), [
  [ 'Name' => ('CounterName'), 'Name', 'string' ],
  [ 'Player' => ('PlayerID'), 'Player', 'player' ],
  [ 'ProtoUnit' => ('ProtoUnit'), 'ProtoUnit', 'protounit' ],
  [ 'Count' => ('Count'), 'Total', 'long' ],
  [ 'Msg' => ('Message'), 'Message', 'stringid' ],
  [ 'Event' => ('Event'), 'Trigger', 'event' ],
 ], [], [
  'trCounterAddUnit("%Name%", %Player%, %Count%, "%ProtoUnit%", "%Msg%", %Event%);', undef,
 ] ],
'Counter Stop' => [ ('Counter Stop'), [
  [ 'Name' => ('CounterName'), 'Name', 'string' ],
 ], [], [
  'trCounterAbort("%Name%");', undef,
 ] ],
'Player LOS Change' => [ ('Player LOS Change'), [
  [ 'Player1' => ('Player1'), 'Player', 'player' ],
  [ 'CanSee' => ('CanSee'), 'Has LOS', 'bool' ],
  [ 'Player2' => ('Player2'), 'Player', 'player' ],
 ], [], [
  'trPlayerModifyLOS(%Player1%, %CanSee%, %Player2%);', undef,
 ] ],
'Flash UI' => [ ('Flash UI'), [
  [ 'Name' => ('UIName'), 'Name', 'string' ],
  [ 'Flash' => ('Flash'), 'Flash', 'bool' ],
 ], [], [
  'trUIFlash("%Name%", %Flash%);', undef,
 ] ],
'Flash UI Tech' => [ ('Flash UI Tech'), [
  [ 'TechID' => ('TechID'), 'Tech', 'tech' ],
  [ 'Flash' => ('Flash'), 'Flash', 'bool' ],
 ], [], [
  'trUIFlashTech(%TechID%, %Flash%);', undef,
 ] ],
'Flash UI Train' => [ ('Flash UI Train'), [
  [ 'ProtoName' => ('ProtoName'), 'ProtoName', 'protounit' ],
  [ 'Flash' => ('Flash'), 'Flash', 'bool' ],
 ], [], [
  'trUIFlashTrain("%ProtoName%", %Flash%);', undef,
 ] ],
'Flash UI Category' => [ ('Flash UI Category'), [
  [ 'CategoryID' => ('CategoryID'), 'Category', 'uicategory' ],
  [ 'Flash' => ('Flash'), 'Flash', 'bool' ],
 ], [], [
  'trUIFlashCategory(%CategoryID%, %Flash%);', undef,
 ] ],
'Flash Units' => [ ('Flash Units'), [
  [ 'SrcObject' => ('SourceUnits'), 'Units', 'unit' ],
  [ 'Duration' => ('Duration'), 'Seconds', 'float' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitHighlight(%Duration%, true);', undef,
 ] ],
'Fade To Color' => [ ('Fade To Color'), [
  [ 'R' => ('Red'), 'Red', 'long' ],
  [ 'G' => ('Green'), 'Green', 'long' ],
  [ 'B' => ('Blue'), 'Blue', 'long' ],
  [ 'Duration' => ('Duration_ms'), 'Duration(ms)', 'long' ],
  [ 'Delay' => ('Delay_ms'), 'Delay(ms)', 'long' ],
  [ 'Fade' => ('Fade'), 'Fade', 'bool' ],
 ], [], [
  'trUIFadeToColor(%R%,%G%,%B%,%Duration%,%Delay%,%Fade%);', undef,
 ] ],
'Fade to Color' => [ ('Fade to Color'), [
  [ 'R' => ('Red'), 'Red', 'long' ],
  [ 'G' => ('Green'), 'Green', 'long' ],
  [ 'B' => ('Blue'), 'Blue', 'long' ],
  [ 'Duration' => ('Duration_ms'), 'Duration(ms)', 'long' ],
  [ 'Delay' => ('Delay_ms'), 'Delay(ms)', 'long' ],
  [ 'Fade' => ('Fade'), 'Fade', 'bool' ],
 ], [], [
  'trUIFadeToColor(%R%,%G%,%B%,%Duration%,%Delay%,%Fade%);', undef,
 ] ],
'Win Message' => [ ('Win Message'), [
  [ 'Text' => ('Text'), 'Text', 'stringid' ],
  [ 'Sound' => ('Sound'), 'Sound', 'sound' ],
 ], [], [
  'trShowWinLose("%Text%", "%Sound%");', undef,
 ] ],
'Advance Campaign' => [ ('Advance Campaign'), [], [], [
  'trCampaignAdvance();', undef,
 ] ],
'Advance Campaign Progress' => [ ('Advance Campaign Progress'), [], [], [
  'trCampaignAdvanceProgress();', undef,
 ] ],
'Advance Campaign Scenario' => [ ('Advance Campaign Scenario'), [], [], [
  'trCampaignPlayCurrent();', undef,
 ] ],
'Rate Construction' => [ ('Rate Construction'), [
  [ 'Rate' => ('Rate'), 'Rate', 'float' ],
 ], [], [
  'trRateConstruction(%Rate%);', undef,
 ] ],
'Rate Training' => [ ('Rate Training'), [
  [ 'Rate' => ('Rate'), 'Rate', 'float' ],
 ], [], [
  'trRateTrain(%Rate%);', undef,
 ] ],
'Rate Research' => [ ('Rate Research'), [
  [ 'Rate' => ('Rate'), 'Rate', 'float' ],
 ], [], [
  'trRateResearch(%Rate%);', undef,
 ] ],
'Rates Normal' => [ ('Rates Normal'), [], [], [
  'trRatesNormal();', undef,
 ] ],
'Go to Main Menu' => [ ('Go to Main Menu'), [], [], [
  'trModeEnter("Pregame");', undef,
 ] ],
'Player Set Active' => [ ('Player Set Active'), [
  [ 'Player' => ('PlayerID'), 'Player', 'player' ],
 ], [], [
  'trPlayerSetActive(%Player%);', undef,
 ] ],
'Flare Minimap' => [ ('Flare Minimap'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'Duration' => ('Duration'), 'Duration', 'float' ],
  [ 'Position' => ('Position'), 'X', 'area' ],
  [ 'Flash' => ('Flash'), 'Flash', 'bool' ],
 ], [], [
  'trMinimapFlare(%PlayerID%, %Duration%, vector(%Position%), %Flash%);', undef,
 ] ],
'Shake Camera' => [ ('Shake Camera'), [
  [ 'Duration' => ('Duration'), 'Duration', 'float' ],
  [ 'Strength' => ('Strength'), 'Strength', 'float' ],
 ], [], [
  'trCameraShake(%Duration%, %Strength%);', undef,
 ] ],
'Player Reset Blackmap' => [ ('Player Reset Blackmap'), [
  [ 'Player' => ('PlayerID'), 'Player', 'player' ],
 ], [], [
  'trPlayerResetBlackMap(%Player%);', undef,
 ] ],
'Reset All Blackmap' => [ ('Reset All Blackmap'), [], [], [
  'trPlayerResetBlackMapForAllPlayers();', undef,
 ] ],
'Player Kill All God Powers' => [ ('Player Kill All God Powers'), [
  [ 'Player' => ('PlayerID'), 'Player', 'player' ],
 ], [], [
  'trPlayerKillAllGodPowers(%Player%);', undef,
 ] ],
'Player Tech Tree Enabled God Powers' => [ ('Player Tech Tree Enabled God Powers'), [
  [ 'Player' => ('PlayerID'), 'Player', 'player' ],
  [ 'Enable' => ('Enable'), 'Enable', 'bool' ],
 ], [], [
  'trPlayerTechTreeEnabledGodPowers(%Player%, %Enable%);', undef,
 ] ],
'Player Destroy All Units' => [ ('Player Destroy All Units'), [
  [ 'Player' => ('PlayerID'), 'Player', 'player' ],
 ], [], [
  'trPlayerKillAllUnits(%Player%);', undef,
 ] ],
'Player Destroy All Buildings' => [ ('Player Destroy All Buildings'), [
  [ 'Player' => ('PlayerID'), 'Player', 'player' ],
 ], [], [
  'trPlayerKillAllBuildings(%Player%);', undef,
 ] ],
'Set Player Defeated' => [ ('Set Player Defeated'), [
  [ 'Player' => ('PlayerID'), 'Player', 'player' ],
 ], [], [
  'trSetPlayerDefeated(%Player%);', undef,
 ] ],
'Set Player Won' => [ ('Set Player Won'), [
  [ 'Player' => ('PlayerID'), 'Player', 'player' ],
 ], [], [
  'trSetPlayerWon(%Player%);', undef,
 ] ],
'Relic Force' => [ ('Relic Force'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'unit' ],
  [ 'TechID' => ('TechID'), 'Tech', 'tech' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trSetRelicType(%TechID%);', undef,
 ] ],
'Unforbid and Enable Unit' => [ ('Unforbid and Enable Unit'), [
  [ 'PlayerID' => ('PlayerID'), 'Player', 'player' ],
  [ 'ProtoUnit' => ('ProtoUnit'), 'Unit', 'protounit' ],
 ], [], [
  'trUnforbidProtounit(%PlayerID%, "%ProtoUnit%");', undef,
 ] ],
'Pause on Age Up' => [ ('Pause on Age Up'), [
  [ 'Pause' => ('Enable'), 'Enable', 'bool' ],
 ], [], [
  'trSetPauseOnAgeUpgrade(%Pause%);', undef,
 ] ],
'FakeCounter Set Text' => [ ('FakeCounter Set Text'), [
  [ 'Text' => ('Text'), 'Text', 'stringid' ],
 ], [], [
  'trSetCounterDisplay("%Text%");', undef,
 ] ],
'FakeCounter Clear' => [ ('FakeCounter Clear'), [], [], [
  'trClearCounterDisplay();', undef,
 ] ],
'Send Spoofed Chat' => [ ('Send Spoofed Chat'), [
  [ 'PlayerID' => ('FakePlayerID'), 'Fake Player', 'player' ],
  [ 'Message' => ('Message'), 'Message', 'stringid' ],
 ], [], [
  'trChatSendSpoofed(%PlayerID%, "%Message%");', undef,
 ] ],
'Play Movie' => [ ('Play Movie'), [
  [ 'FileName' => ('FileName'), 'FileName', 'string' ],
 ], [], [
  'trPlayMovie("%FileName%");', undef,
 ] ],
'End Game' => [ ('End Game'), [], [], [
  'trEndGame();', undef,
 ] ],
'Reveal Map' => [ ('Reveal Map'), [], [], [
  'trRevealEntireMap();', undef,
 ] ],
'Branch Scenario' => [ ('Branch Scenario'), [
  [ 'Text' => ('Text'), 'Text', 'stringid' ],
 ], [], [
  'trBranchScenario("%Text%");', undef,
 ] ],
'Pause In Objective Window' => [ ('Pause In Objective Window'), [
  [ 'Pause' => ('Enable'), 'Enable', 'bool' ],
 ], [], [
  'trSetPauseInObjectiveWindow(%Pause%);', undef,
 ] ],
'Win/Lose Message' => [ ('Win/Lose Message'), [
  [ 'Text' => ('Text'), 'Text', 'stringid' ],
  [ 'Sound' => ('Sound'), 'Sound', 'sound' ],
 ], [], [
  'trShowWinLose("%Text%", "%Sound%");', undef,
 ] ],

'Change Current HP' => [ ('Change Current HP'), [
  [ 'SrcObject' => ('SourceUnits'), 'Unit', 'unit' ],
  [ 'ScenName' => ('HitPoints'), 'HP', 'string' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitSetHP(%ScenName%);', undef,
 ] ],
'Set Current HP by EO(http://mods.dgdn.net)' => [ ('Set Current HP by EO'), [
  [ 'SrcObject' => ('SourceUnits'), 'Unit', 'unit' ],
  [ 'ScenName' => ('HitPoints'), 'HP', 'string' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitSetHP(%ScenName%);', undef,
 ] ],
'Set Current HP' => [ ('Set Current HP'), [
  [ 'SrcObject' => ('SourceUnits'), 'Unit', 'unit' ],
  [ 'ScenName' => ('HitPoints'), 'HP', 'string' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitSetHP(%ScenName%);', undef,
 ] ],

'Kill this unit' => [ ('Kill By Name'), [
  [ 'SrcObject' => ('SourceUnits'), 'Units', 'string' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitDelete(false);', undef,
 ] ],
'Is Dead' => [ ('Destroy By Name'), [
  [ 'SrcObject' => ('SourceUnits'), 'Unit', 'string' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitDestroy();', undef,
 ] ],
'Teleport Units' => [ ('Teleport Units By Name'), [
  [ 'SrcObject' => ('SourceUnits'), 'Source Units', 'string' ],
  [ 'Area' => ('Area'), '', 'area' ],
 ], [], [
  'trUnitSelectClear();', undef,
  'trUnitSelect("%SrcObject%");', 'SrcObject',
  'trUnitTeleport(%Area%);', undef,
 ] ],

'xsGlobalsStart' => [ ('xsGlobalsStart'), [
 ], [], [
  '}', undef,
  '}', undef,
 ] ],
'xsGlobalsEnd' => [ ('xsGlobalsEnd'), [
 ], [], [
  'rule _DeclareGlobalsEnd', undef,
  'inactive', undef,
  '{', undef,
  'if (0==0) {', undef,
 ] ],
'xsUserCode' => [ ('xsUserCode'), [
  [ 'MyString' => ('Code'), 'Code', 'string' ],
 ], [], [
  '/**/ %MyString%',
 ] ],


] );

1;
